Contracts = {}

Contracts.modDirectory = g_currentModDirectory

function Contracts:init()

    MissionManager.initDataStructures = Utils.appendedFunction(MissionManager.initDataStructures, Contracts.initDataStructures)
    MissionManager.loadMapData = Utils.appendedFunction(MissionManager.loadMapData, Contracts.initDataStructures)

    InGameMenuContractsFrame.onFrameOpen = Utils.appendedFunction(InGameMenuContractsFrame.onFrameOpen, Contracts.onFrameOpen)
    InGameMenuContractsFrame.onFrameClose = Utils.appendedFunction(InGameMenuContractsFrame.onFrameClose, Contracts.onFrameClose)
    AbstractMission.hasLeasableVehicles = Utils.overwrittenFunction(AbstractMission.hasLeasableVehicles, Contracts.hasLeasableVehicles)

   --MissionVehicles
    MissionManager.loadVehicleGroups = Utils.overwrittenFunction(MissionManager.loadVehicleGroups, Contracts.loadVehicleGroups)

end

function Contracts:onFrameOpen()
    Contracts:addButtons(self)

end

function Contracts:addButtons(menuFrame)
    local menuContainer = g_inGameMenu.menuButton[1].parent
    local menuButton = g_inGameMenu.menuButton[1]
    if g_inGameMenu.newContractsButton == nil then
        g_inGameMenu.newContractsButton = menuButton:clone(menuFrame)
        g_inGameMenu.newContractsButton.onClickCallback = Contracts.onClickNewCallback
        g_inGameMenu.newContractsButton:setText(g_i18n:getText("new_contracts"))
        g_inGameMenu.newContractsButton:setInputAction("MENU_EXTRA_1")
    end

    if g_inGameMenu.clearContractsButton == nil then
        g_inGameMenu.clearContractsButton = menuButton:clone(menuFrame)
        g_inGameMenu.clearContractsButton.onClickCallback = Contracts.onClickClearCallback
        g_inGameMenu.clearContractsButton:setText(g_i18n:getText("clear_contracts"))
        g_inGameMenu.clearContractsButton:setInputAction("MENU_EXTRA_2")
    end
    menuContainer:addElement(g_inGameMenu.newContractsButton)
    menuContainer:addElement(g_inGameMenu.clearContractsButton)
    menuContainer:invalidateLayout()


    local clearAddVisble = g_r_contracts.allowClearAdd == 2

    g_inGameMenu.clearContractsButton.visible = clearAddVisble
    g_inGameMenu.newContractsButton.visible = clearAddVisble
end

function Contracts:hasLeasableVehicles()
    local canLeaseVehicles = g_r_contracts.leaseVehicle == 2
    return canLeaseVehicles and table.getn(self.vehiclesToLoad) > 0
end


function Contracts:onFrameClose()
    if  g_inGameMenu.clearContractsButton == nil then
        return
    end
    g_inGameMenu.clearContractsButton.visible = false
    g_inGameMenu.newContractsButton.visible = false
end

function Contracts:onClickNewCallback()
    g_client:getServerConnection():sendEvent(CreateContractsEvent:new())
end

function Contracts:onClickClearCallback()
    g_client:getServerConnection():sendEvent(ClearContractsEvent:new())
end

function Contracts:initDataStructures()
    MissionManager.MAX_MISSIONS = 100
    MissionManager.ACTIVE_CONTRACT_LIMIT = 50
    MissionManager.MAX_MISSIONS_PER_GENERATION = 10 --4
    MissionManager.MAX_TRIES_PER_GENERATION = 20 --5
    MissionManager.MAX_MISSIONS_PER_FARM = 25
    MissionManager.MAX_TRIES_PER_GENERATION = 100
end

function Contracts.loadVehicleGroups(superSelf, superFunc, path)
        local path2 = Utils.getFilename("missionVehicles.xml", Contracts.modDirectory)
    if path2 ~= nil then
        return superFunc(superSelf, path2)
    end
end

Contracts:init()